#include <stdlib.h>
#include <SDL/SDL.h>
#include "structures.h"
#include "partie.h"
#include "joueur.h"
#include "joueurList.h"
#include "personnage.h"
#include "case.h"
#include "deplacements.h"
#include "SDL.h"
#include "controleurSDL.h"

/*!
* \file SDL.c
* \brief Fichier contenant le code des fonctions liees  l'affichage par la SDL.
*/


int main_SDL()
{
    int i,j;
    SDL_Surface* ecran=NULL;
    SDL_Event event;
    SDL_Surface* perso[NB_PERSO]={NULL};
    SDL_Surface* Case=NULL;
    SDL_Surface* Case_brillante=NULL;
    SDL_Rect Position_Case[LARGEUR_CARTE*HAUTEUR_CARTE];
    SDL_Rect Position_Perso[NB_PERSO];
    SDL_Rect Position_Case_brillante;
    int x_case_brillante;
    int y_case_brillante;
    int quitter=0;

    if ( SDL_Init( SDL_INIT_VIDEO ) < 0 )
    {
        printf( "Unable to init SDL: %s\n", SDL_GetError() );
        return 1;
    }

    ecran = SDL_SetVideoMode(LARGEUR_CARTE*(LARGEUR_CASE+1), HAUTEUR_CARTE*(HAUTEUR_CASE+2), 32, SDL_HWSURFACE|SDL_DOUBLEBUF);
    if (ecran == NULL) // Si l'ouverture a chou, on le note et on arrte
    {
        fprintf(stderr, "Impossible de charger le mode vido : %s\n", SDL_GetError());
        exit(EXIT_FAILURE);
    }

    SDL_WM_SetCaption("Elder Internal Ignition",NULL);

    perso[0] = SDL_LoadBMP("../resources/personnage.bmp");
        if (!perso[0])
        {
            printf("Unable to load bitmap: %s\n", SDL_GetError());
            return 1;
        }
    SDL_SetColorKey(perso[0], SDL_SRCCOLORKEY, SDL_MapRGB(perso[0]->format, 0, 0, 255));
    Case = SDL_LoadBMP("../resources/normal2.bmp");
    if (!Case)
        {
            printf("Unable to load bitmap: %s\n", SDL_GetError());
            return 1;
        }
    SDL_SetColorKey(Case, SDL_SRCCOLORKEY, SDL_MapRGB(Case->format, 0, 0, 255));

    Case_brillante = SDL_LoadBMP("../resources/normal2_brillant.bmp");
                    if (!Case_brillante)
                    {
                        printf("Unable to load bitmap: %s\n", SDL_GetError());
                        return 1;
                    }
    SDL_SetColorKey(Case_brillante, SDL_SRCCOLORKEY, SDL_MapRGB(Case->format, 0, 0, 255));

    for(i=0;i<LARGEUR_CARTE;i+=2)
    {
        for(j=0;j<HAUTEUR_CARTE;j++)
            {
                Position_Case[j*LARGEUR_CARTE+i].x=LARGEUR_CASE*i;
                Position_Case[j*LARGEUR_CARTE+i].y=HAUTEUR_CASE*j;
            }
    }
    for(i=1;i<LARGEUR_CARTE;i+=2)
    {
        for(j=0;j<HAUTEUR_CARTE;j++)
            {
                Position_Case[j*LARGEUR_CARTE+i].x=LARGEUR_CASE*i;
                Position_Case[j*LARGEUR_CARTE+i].y=HAUTEUR_CASE*j+(HAUTEUR_CASE/2);
            }
    }

    init_controleur(Position_Case);

    while(quitter==0)
    {
        SDL_WaitEvent(&event);
        switch(event.type) /* Test du type d'vnement */
        {
            case SDL_QUIT: /* Si c'est un vnement de type "Quitter" */
                quitter=1;
                break;
            case SDL_MOUSEBUTTONDOWN:
                deplacement_personnage(0,event.button.x,event.button.y);
                break;
            case SDL_MOUSEMOTION:
                if(event.motion.x<LARGEUR_CARTE*LARGEUR_CASE&&event.motion.y<HAUTEUR_CARTE*HAUTEUR_CASE)
                {
                    x_case_brillante = get_position_case_x(deplacement_brillance(event.motion.x,event.motion.y));
                    y_case_brillante = get_position_case_y(deplacement_brillance(event.motion.x,event.motion.y));
                }
                break;
            case SDL_KEYDOWN:/* Si c'est un vnement de type "touche presse" */
                switch(event.key.keysym.sym){
                    case SDLK_ESCAPE:
                        quitter=1;
                        break;
                    default:
                        quitter=0;
                }
             break;
        }
        Position_Perso[0].x=get_position_perso_x(0);
        Position_Perso[0].y=get_position_perso_y(0);
        Position_Case_brillante.x=x_case_brillante;
        Position_Case_brillante.y=y_case_brillante;
        SDL_FillRect(ecran,NULL,SDL_MapRGB(ecran->format,0,0,0));
        for(i=0;i<LARGEUR_CARTE*HAUTEUR_CARTE;i++)
        {
            SDL_BlitSurface(Case,NULL,ecran,&Position_Case[i]);
        }
        SDL_BlitSurface(Case_brillante,NULL,ecran,&Position_Case_brillante);
        SDL_BlitSurface(perso[0],NULL,ecran,&Position_Perso[0]);
        SDL_Flip(ecran);
    }
    quitter=0;
    SDL_FreeSurface(Case);
    SDL_FreeSurface(Case_brillante);
    SDL_FreeSurface(perso[0]);
    SDL_Quit();
    return 0;
}


